// datablock TSShapeConstructor(SharkIIPartsArmorDts)
// {
//     baseShape  = "./shapes/sharkPartsBot.dts";
//     sequence0  = "./lightbot.dsq root";
//     sequence1  = "./lightbot.dsq lightsup";
//     sequence2  = "./lightbot.dsq lightsdown";
// };

datablock PlayerData(SharkIIPartsArmor)
{
    shapeFile = "./shapes/sharkPartsBot.dts";
    boundingBox = "50 50 50";
    splashEmitter[0] = PlayerFoamDropletsEmitter;
    splashEmitter[1] = PlayerFoamEmitter;
    splashEmitter[2] = PlayerBubbleEmitter;

    maxDamage = 10;
    
    useCustomPainEffects = true;
    PainHighImage = "";
    PainMidImage  = "";
    PainLowImage  = "";
    painSound     = "";
    deathSound    = "";
};

function AIPlayer::setMountedLight(%this, %data)
{
    if (isObject(%this.mountedLight))
        %this.mountedLight.delete();

    if (isObject(%data))
    {
        %this.mountedLight = new fxLight()
        {
            datablock = %data;
            position = %this.position;
        };

        MissionCleanup.add(%this.mountedLight);
        %this.mountedLight.attachToObject(%this);
    }
}

function WheeledVehicle::spawnSharkIIMountedLightBot(%this, %slot)
{
    %player = new AIPlayer()
    {
        datablock = SharkIIPartsArmor;
        position = %this.position;
    };

    MissionCleanup.add(%player);

    %this.mountedLightBot[%slot] = %player;
    %player.setDamageLevel(10);
    %this.mountObject(%player, %slot);

    return %player;
}

function WheeledVehicle::removeMountedLightBot(%this, %slot)
{
    %player = %this.mountedLightBot[%slot];

    if (isObject(%player))
    {
        if (isObject(%player.mountedLight))
            %player.mountedLight.delete();

        %player.delete();
    }
}

function AIPlayer::RemoveBody(%obj)
{
    if(%obj.getDatablock() == SharkIIPartsArmor.getID())
    {
        return;
    }
    else
    {
        return Parent::RemoveBody(%obj);
    }
}