datablock fxLightData(sharkIIHeadLight)
{
	radius = 50;
	brightness = 4;
	color = "1 0.85 0.70 1";
	flareOn = false;
};

datablock ParticleData(denseShortTireParticle)
{
  dragCoefficient = 99;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 150;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = 0;
  spinRandomMax = 0;
  colors[0] = "0.1 0.1 0.1 0.5";
  colors[1] = "0.1 0.1 0.1 0";
  sizes[0] = 0.6;
  sizes[1] = 0.6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(denseShortTireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "denseShortTireParticle";
  useEmitterColors = true;
};

datablock WheeledVehicleData(sharkIIvehicle)
{
	category = "Vehicles";
	uiName = "Shark II '70 Powerful";
	shapeFile = "./shapes/sharkii.dts";
	
	handsOnVehicle = 1;
	shiftBrickCarControls = 1;
	hasScriptedHeadlights = 1;
	usesVehicleEditHelper = 1;
	storedColorScheme = 1;
	colorSchemeIdentifier = "sharkII";

	defaultTire = sharkIItire;
	defaultSpring = sharkIIspring;

	tireEmitter = denseShortTireEmitter;

	numFactoryColorGroups = 4;

	numFactoryColors[0] = 23;

	factoryColor[0, 1] = "BB2020 Red";
	factoryColor[0, 2] = "3576B2 Bright blue";
	factoryColor[0, 3] = "E0BE4E Bright yellow";
	factoryColor[0, 4] = "FF451A Relentless orange";
	factoryColor[0, 5] = "CC5A14 '70s orange";
	factoryColor[0, 6] = "071E4C Dark blue";
	factoryColor[0, 7] = "173324 British green";
	factoryColor[0, 8] = "074740 Blue-green";
	factoryColor[0, 9] = "3A0E0E Burgundy";
	factoryColor[0, 10] = "CCC170 Pale yellow";
	factoryColor[0, 11] = "6D1B1B Mahogany";
	factoryColor[0, 12] = "8C763F Gold";
	factoryColor[0, 13] = "7F3E26 Bronze";
	factoryColor[0, 14] = "334866 Steel blue";
	factoryColor[0, 15] = "99823D '70s yellow";
	factoryColor[0, 16] = "455634 '70s green";
	factoryColor[0, 17] = "2F7032 Bright green";
	factoryColor[0, 18] = "33291E Brown";
	factoryColor[0, 19] = "F0F0F0 White";
	factoryColor[0, 20] = "AAADB2 Silver";
	factoryColor[0, 21] = "808480 Gray";
	factoryColor[0, 22] = "4C4C4C Dark gray";
	factoryColor[0, 23] = "1A1A1A Black";

	//Yes, I'm using a string to represent an array of numbers. Blame torquescript.
	//Which interior colors match?
	factoryColorSuggestedInterior[1] = "1 2 3 4 5 6 9 13 19 20";
	factoryColorSuggestedInterior[2] = "1 2 9 10 11 12 19";
	factoryColorSuggestedInterior[3] = "1 2 3 4 7 9 16 19";
	factoryColorSuggestedInterior[4] = "1 2 3 5 16 19";
	factoryColorSuggestedInterior[5] = "1 2 7";
	factoryColorSuggestedInterior[6] = "1 2 6 9 12";
	factoryColorSuggestedInterior[7] = "1 2 3 4 5 7 8 15 19 20";
	factoryColorSuggestedInterior[8] = "1 2 4 6";
	factoryColorSuggestedInterior[9] = "1 2 4";
	factoryColorSuggestedInterior[10]= "1 8";
	factoryColorSuggestedInterior[11]= "1 2 3 5 6 19 20";
	factoryColorSuggestedInterior[12]= "1 2 3";
	factoryColorSuggestedInterior[13]= "1 14 17";
	factoryColorSuggestedInterior[14]= "1 10 19";
	factoryColorSuggestedInterior[15]= "1 2 7";
	factoryColorSuggestedInterior[16]= "1 2";
	factoryColorSuggestedInterior[17]= "1 2 3 19";
	factoryColorSuggestedInterior[18]= "1 2 3 5 16 19 20";
	factoryColorSuggestedInterior[19]= "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20";
	factoryColorSuggestedInterior[20]= "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20";
	factoryColorSuggestedInterior[21]= "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20";
	factoryColorSuggestedInterior[22]= "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20";
	factoryColorSuggestedInterior[23]= "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20";

	numFactoryColors[1] = 20;

	factoryColor[1, 1] = "1B1F1E Black";
	factoryColor[1, 2] = "BFA269 Saddle";
	factoryColor[1, 3] = "D9CCBD Neutral";
	factoryColor[1, 4] = "99633D Brown";
	factoryColor[1, 5] = "F2E39F Beige";
	factoryColor[1, 6] = "7F3333 Dark red";
	factoryColor[1, 7] = "1F3F2F Dark green";
	factoryColor[1, 8] = "566641 Green";
	factoryColor[1, 9] = "073763 Bluest";
	factoryColor[1, 10] = "0B5394 Bluer";
	factoryColor[1, 11] = "3C78D8 Blue";
	factoryColor[1, 12] = "6FA8DC Bluish";
	factoryColor[1, 13] = "BF2630 Red";
	factoryColor[1, 14] = "99493D Bronze";
	factoryColor[1, 15] = "3F7A7F Blue green";
	factoryColor[1, 16] = "594635 Dark brown";
	factoryColor[1, 17] = "332519 Tobacco";
	factoryColor[1, 18] = "444444 Guns";
	factoryColor[1, 19] = "999999 Silver";
	factoryColor[1, 20] = "EEEEEE Why";

	// factoryColor[1, 1] = "1B1F1E Black"; //BK
	// factoryColor[1, 2] = "593C28 Brown"; //BR
	// factoryColor[1, 3] = "B58048 Tan";   //S
	// factoryColor[1, 4] = "BF2635 Red";   //R
	// factoryColor[1, 5] = "4E663D Green"; //G
	// factoryColor[1, 6] = "33597F Blue";  //B

	numFactoryColors[2] = 1;
	factoryColor[2, 1] = "BFBFBF Gray75";

	numFactoryColors[3] = 2;
	factoryColor[3, 1] = "202020 Black";
	factoryColor[3, 2] = "FCFDED White";

	visPartsList = "roofcover roof headlight hood exhaust flare vent bumper stripe rack luggage";
	visPartNum["roofcover"] = 2;
	visPartNum["roof"] = 3;
	visPartNum["headlight"] = 2;
	visPartNum["hood"] = 4;
	visPartNum["exhaust"] = 2;
	visPartNum["flare"] = 3;
	visPartNum["vent"] = 3;
	visPartNum["bumper"] = 3;
	visPartNum["stripe"] = 3;
	visPartNum["rack"] = 2;
	visPartNum["luggage"] = 2;

	visPartDefault["roofcover"] = 0;
	visPartDefault["roof"] = 0;
	visPartDefault["headlight"] = 0;
	visPartDefault["hood"] = 1;
	visPartDefault["exhaust"] = 0;
	visPartDefault["flare"] = 0;
	visPartDefault["vent"] = 1;
	visPartDefault["bumper"] = 0;
	visPartDefault["stripe"] = 0;
	visPartDefault["rack"] = 0;
	visPartDefault["luggage"] = 1;

	engineTorque = 7500;
	engineBrake = 750;
	brakeTorque = 3000;
	maxWheelSpeed = 75;

	mass = 300;
	massCenter = "0 0 0.2";
	
	rotationalDrag = 0;
	drag = 1;
	bodyFriction = 0.25;
	bodyRestitution = 0.25;

	displayName = "";
	emap = true;
	minMountDist = 3;

	numMountPoints = 2;
	mountThread[0] = "sit";
	mountThread[1] = "sit";

	rollForce = 0;
	yawForce = 0;
	pitchForce = 1000;

	rideable = true;
	lookUpLimit = 0.6;
	lookDownLimit = 0.5;
 
	paintable = true;

	maxDamage = 200.00;
	destroyedLevel = 400.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	maxSteeringAngle = 0.85;
	integration = 4;
	//tireEmitter = none;

	cameraRoll = false;
	cameraMaxDist = 10;
	cameraOffset = 4;
	cameraTilt = 0.3;

	cameraLag = 0.0;
	cameraDecay = 0.75;
	collisionTol = 0.1;
	contactTol = 0.1;

	useEyePoint = false;	

	numWheels = 4;

	density = 5.0;
	minImpactSpeed = 10;
	softImpactSpeed = 10;
	hardImpactSpeed = 15;
	groundImpactMinSpeed = 10.0;

	steeringAutoReturn = true;
	steeringAutoReturnRate = 0.05;
	steeringAutoReturnMaxSpeed = 0.1;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.05;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
   
	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = vehicleExplosionProjectile;
	initialExplosionOffset = 0;

	burnTime = 4000;

	finalExplosionProjectile = vehicleFinalExplosionProjectile;
	finalExplosionOffset = 0.5;

	minRunOverSpeed    = 4;
	runOverDamageScale = 8;
	runOverPushScale   = 1.2;

	protectPassengersBurn   = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;
};
