function strIsNum(%str)
{
    %table = "-.1234567890";
    %len = strlen(%str);
    if(%len == 0)
        return false;
    for(%i = 0; %i < %len; %i ++)
    {
        if(strPos(%table, getSubStr(%str, %i, 1)) == -1)
            return false;
    }
    return true;
}

function sharkIIvehicle::generateFactoryColorStrings(%this)
{
    //announce("Generating factory color strings...");
    for(%j = 0; %j < %this.numFactoryColorGroups; %j++)
    {
        %this.factoryColorString[%j] = "";
        // announce("Group " @ %j @ ": Factory colors: " @ %this.numFactoryColors[%j]);
        if(%this.numFactoryColors[%j] <= 12)
        {
            // announce("Group " @ %j @ " is short");
            for(%i = 1; %i <= %this.numFactoryColors[%j]; %i++)
            {
                %this.factoryColorString[0, %j] = %this.factoryColorString[0, %j] @ "<color:" @ getWord(%this.factoryColor[%j, %i], 0) @ ">[" @ %i @ "]";
            }
        }
        else
        {
            for(%i = 1; %i <= 12; %i++)
            {
                %this.factoryColorString[0, %j] = %this.factoryColorString[0, %j] @ "<color:" @ getWord(%this.factoryColor[%j, %i], 0) @ ">[" @ %i @ "]";
            }
            %this.factoryColorString[1, %j] = "";
            for(%i = 13; %i <= %this.numFactoryColors[%j]; %i++)
            {
                %this.factoryColorString[1, %j] = %this.factoryColorString[1, %j] @ "<color:" @ getWord(%this.factoryColor[%j, %i], 0) @ ">[" @ %i @ "]";
            }
        }
    }


}

sharkIIvehicle.generateFactoryColorStrings();

function sharkIIvehicle::displayColorTargets(%this, %veh, %c)
{
    if(%brick.reColorVehicle) %color = "\c8";
    else if(0 == %veh.colorSchemeTarget)%color= "\c3";
                                  else %color = "\c7";

    %c.chatMessage("            \c4T 0 \c8- " @ %color @ %veh.colorSchemeName[0]);

    for(%i = 1; %i < %veh.numColorSchemeTargets; %i++)
    {
        if(%i == 0 || strlen(%veh.colorSchemeNodes[%i]) != 0)
        {
            if(%i == %veh.colorSchemeTarget)
                %color = "\c3";
            else if (getWord(%veh.colorSchemeColor[%i], 3) != 1 || strlen(%veh.colorSchemeNodes[%i]) == 0)
                %color = "\c8";
            else
                %color = "\c7";

            %c.chatMessage("            \c4T " @ %i @ " \c8- " @ %color @ %veh.colorSchemeName[%i]);
        }
    }
}

function sharkIIvehicle::displayFactoryColorString(%this, %veh, %c)
{   
    if(%veh.colorSchemeTarget == 0 && %brick.reColorVehicle)
    {
        %c.chatMessage("    \c7Colors for current target: \c8N/A - \c0Re-Color Vehicle\c6 is checked on the vehicle's spawn brick. Base colors are unavailable.");
    }
    else
    {
        // announce("Factory colors on current target: " @ %this.numFactoryColors[%veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]]);
        %c.chatMessage("    \c7Colors for current target: " @  %this.factoryColorString[0, %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]]);
        if(%this.numFactoryColors[%veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]] > 10)
        {
            %c.chatMessage("    " @  %this.factoryColorString[1, %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget]]);
        }
    }

    return;
}

function sharkIIvehicle::deleteCurrentPaintTarget(%this, %veh, %c, %vehname)
{
    %c.chatMessage();
    %veh.colorSchemeColor[%veh.colorSchemeTarget] = "0 0 0 0";
    %veh.spawnbrick.colorSchemeColor[%this.colorSchemeIdentifier, %veh.colorSchemeTarget] = "0 0 0 0";
    %c.chatMessage(%vehname @ "\c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget] @ "\c6 now matches base color. Paint target changed to \c40: \c3" @ %veh.colorSchemeName[0]);
    %veh.colorSchemeTarget = 0;
    %veh.setNodeColor("ALL", %veh.colorSchemeColor[0]);
    sharkIIvehicle.displayFactoryColorString(%veh, %c);
    sharkIIvehicle.displayColorTargets(%veh, %c);
}

function sharkIIvehicle::listVisPartSelection(%this, %veh, %part, %color)
{
    for(%i = 0; %i < %this.visPartNum[%part]; %i++)
    {
        if(%i > 0)
        {
            %output = %output @ " ";
        }
        if(%veh.visPart[%part] == %i)
        {
            %output = %output @ %color @ %i;
        }
        else
        {
            %output = %output @ "\c8" @ %i;
        }
    }

    return %output;
}

function sharkIIvehicle::VehicleEditHelper(%this, %veh, %c, %arg1, %arg2, %arg3)
{
    %vehname = "\c5Shark VEH\c6: ";
    %this = %this.getid();
    %brick = %veh.spawnbrick;
    %ID = %this.colorSchemeIdentifier;

    if(getSimTime() - %c.VEHactivationTimer < 250)
    {
        %c.VEHactivationTimer = getSimTime();
        return %c.chatMessage(%vehname @ "Let's not activate complicated scripts too quickly.");
    }
    %c.VEHactivationTimer = getSimTime();

    if(getTrustLevel(%c, %veh) < 2)
        return %c.chatMessage(%vehname @ "You can't change a vehicle without the owner's trust.");

        //Screw that, this restriction is mostly just annoying to me at this point.
    // %veh.speed = vectorLen(%veh.getVelocity());
    // if(%veh.speed > 5)   
    //  return %c.chatMessage("\c3The vehicle can't be customized while in motion.");

    if(!strIsNum(%arg1))
    {
        //visPartsList = "roofcover roof headlight hood exhaust flare vent bumper stripe";
        //visPartNum["roofcover"] = 2;
        //visPartNum["roof"] = 3;
        //visPartNum["headlight"] = 2;
        //visPartNum["hood"] = 4;
        //visPartNum["exhaust"] = 2;
        //visPartNum["flare"] = 2;
        //visPartNum["vent"] = 3;
        //visPartNum["bumper"] = 2;
        //visPartNum["stripe"] = 3;



        if(%arg1 $= "W")
        {
            if(%arg2 $= "") %arg2 = -1;
            switch(%arg2)
            {
                case 0:
                    %brick.wheelCurrent[%ID] = 0;
                    %c.chatMessage(%vehname @ "Wheels will be the default for this variant. Respawn the car to apply changes.");
                case 1:
                    %brick.wheelCurrent[%ID] = 1;
                    %c.chatMessage(%vehname @ "Wheels set to stock with letters. Respawn the car to apply changes.");
                case 2:
                    %brick.wheelCurrent[%ID] = 2;
                    %c.chatMessage(%vehname @ "Wheels set to stock with a white line. Respawn the car to apply changes.");
                case 3:
                    %brick.wheelCurrent[%ID] = 3;
                    %c.chatMessage(%vehname @ "Wheels set to stock with a red line. Respawn the car to apply changes.");
                case 4:
                    %brick.wheelCurrent[%ID] = 4;
                    %c.chatMessage(%vehname @ "Wheels set to wider five spoke rims. Respawn the car to apply changes.");
                case 5:
                    %brick.wheelCurrent[%ID] = 5;
                    %c.chatMessage(%vehname @ "Wheels set to very wide five spoke rims. Wide fender flares (\c3/veh f 2\c6) recommended! Respawn the car to apply changes.");
                default:
                    %c.chatMessage("\c0-----\c5Shark II Wheel options\c0-----");
                    %c.chatMessage("    \c7/veh \c5w 0 \c8- \c6Default wheels for this variant");
                    %c.chatMessage("    \c7/veh \c5w 1 \c8- \c6Stock narrow");
                    %c.chatMessage("    \c7/veh \c5w 2 \c8- \c6Stock narrow with white line");
                    %c.chatMessage("    \c7/veh \c5w 3 \c8- \c6Stock narrow with red line");
                    %c.chatMessage("    \c7/veh \c5w 4 \c8- \c6Five spoke");
                    %c.chatMessage("    \c7/veh \c5w 5 \c8- \c6Five spoke with very wide rear wheels");
            }
            return;
        }

        if(getSubStr(%arg1, 0, 1) $= "p")
        {

            %c.chatMessage("\c0-----\c1Shark II Visual Parts\c0-----");
            %c.chatMessage("    \c7/veh \c0B \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "bumper", "\c0") @ "\c8] \c0Bumpers");
            %c.chatMessage("    \c7/veh \c1H \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "hood", "\c1") @ "\c8] \c1Hood");
            %c.chatMessage("    \c7/veh \c2RT \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "roof", "\c2") @ "\c8] \c2Roof style");
            %c.chatMessage("    \c7/veh \c3R \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "roofcover", "\c3") @ "\c8] \c3Roof cover");
            %c.chatMessage("    \c7/veh \c4LR \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "rack", "\c4") @ "\c8] \c4Luggage rack");
            %c.chatMessage("    \c7/veh \c5L \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "luggage", "\c5") @ "\c8] \c5Luggage");
            %c.chatMessage("    \c7/veh \c0S \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "stripe", "\c0") @ "\c8] \c0Stripe");
            %c.chatMessage("    \c7/veh \c1E \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "exhaust", "\c1") @ "\c8] \c1Exhaust");
            %c.chatMessage("    \c7/veh \c2HL \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "headlight", "\c2") @ "\c8] \c2Headlights");
            %c.chatMessage("    \c7/veh \c3V \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "vent", "\c3") @ "\c8] \c3Vents");
            %c.chatMessage("    \c7/veh \c4F \c8- [" @ sharkIIvehicle.listVisPartSelection(%veh, "flare", "\c4") @ "\c8] \c4Fender flares");
            %c.chatMessage("    \c7/veh \c5W \c8- <color:aaaaaa>Select \c5wheels<color:aaaaaa>! 1 through 3 are stock, 4 and 5 are performance tires. 0 for default.");
            %c.chatMessage("    \c7/veh \c0reset \c8- \c0Clear saved preferences");
            return;
        }

        switch$(%arg1)
        {
            case "R":
                %part = "roofcover";
            case "RT":
                %part = "roof";
            case "HL":
                %part = "headlight";
            case "H":
                %part = "hood";
            case "E":
                %part = "exhaust";
            case "F":
                %part = "flare";
            case "V":
                %part = "vent";
            case "B":
                %part = "bumper";
            case "S":
                %part = "stripe";
            case "LR":
                %part = "rack";
            case "L":
                %part = "luggage";
            default:
                %part = "none";
        }

        if(%part !$= "none")
        {
            %brick.visPartManuallySet[%part, %ID] = true;
            if(strIsNum(%arg2))
            {
                %veh.visPart[%part] = %arg2;
                if(%veh.visPart[%part] >= %this.visPartNum[%part])
                {
                    %veh.visPart[%part] = %this.visPartNum[%part] - 1;
                    %c.chatMessage(%vehname @ "Selection was too high. Part has been set to the highest available number.");
                }
                if(%veh.visPart[%part] < 0)
                {
                    %veh.visPart[%part] = %this.visPartDefault[%part];
                    %brick.visPartManuallySet[%part, %ID] = false;
                    %c.chatMessage(%vehname @ "Part reset to default for this variant.");
                }
            }
            else
            {
                %veh.visPart[%part] = %veh.visPart[%part] + 1;
                if(%veh.visPart[%part] >= %this.visPartNum[%part])
                    %veh.visPart[%part] = 0;
            }

            //announce("%veh.visPart["@%part@"] is: "@%veh.visPart[%part]);

            return %this.applyParts(%veh, %part, %c, %vehname);
        }
    }

    if(%arg1 $= "reset")
    { 
        %c.VEHactivationTimer = %c.VEHactivationTimer + 750;
        %brick.carAttributesSet[%ID] = false;
        for(%i = 0; %i < getWordCount(%this.visPartsList); %i++)
        {
            %brick.visPartManuallySet[getWord(%this.visPartsList, %i), %ID] = false;
        }
        %brick.wheelCurrent[%ID] = 0;

        %this.loadSpawnBrickAttributes(%veh);
        return %c.chatMessage(%vehname @ "Saved preferences cleared! Applying default appearance and random color.");
    }

    if(getSubStr(%arg1, 0, 2) $= "ra")
    {
        %c.VEHactivationTimer = %c.VEHactivationTimer + 750;
        %this.setDefaultBrickAttributes(%veh);
        return%c.chatMessage(%vehname @ "Vehicle factory color randomized!");
    }



    // if(1)//!%brick.reColorVehicle)
    // {
        if(%arg1 $= "c") //View factory colors
        {
            ///

            // if(strIsNum(%arg2) && %arg2 >= 0 && %arg2 < %veh.numFactoryColorGroups)
            // {
            //  %factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%arg2];
            // }
            // else
            // {
                %factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget];
            // }

            ///

            %c.chatMessage("\c0-----\c7Shark II \c3"@ %veh.colorSchemeName[%veh.colorSchemeTarget] @"\c7 Factory Colors\c0-----");
            // %c.chatMessage("        \c6If you type two numbers, you can use the factory colors for a different target.");

            if(%veh.colorSchemeTarget == 0 && %brick.reColorVehicle)
            {
                %c.chatMessage("\c8N/A - \c0Re-Color Vehicle\c6 is checked on the vehicle's spawn brick. Base colors are unavailable.");
            }
            else 
            {
                if(%veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget] == 0)
                {
                    %c.chatMessage("    \c6The numbers next to these colors are the suggested interior colors. Try \c3/veh t 2 \c0#\c6 to apply one.");
                }

                for(%i = 1; %i <= %this.numFactoryColors[%factoryColorGroup]; %i++)
                {
                    %c.chatMessage("    \c7/veh \c6" @ %i @ "\c8 - <color:" @ getWord(%this.factoryColor[%factoryColorGroup, %i], 0) @ ">[" @ getWords(%this.factoryColor[%factoryColorGroup, %i], 1) @ "]");
                }
            }

            return;
        }
        
        if(strIsNum(%arg1)) //Apply factory colors
        {
            ///

            // if(strIsNum(%arg2) && %arg2 >= 0 && %arg2 < %veh.numFactoryColorGroups)
            // {
            //  %factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%arg2];
            // }
            // else
            // {
                %factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget];
            // }

            ///
            if(%veh.colorSchemeTarget == 0 && %brick.reColorVehicle)
            {
                return %c.chatMessage("\c0Re-Color Vehicle\c6 is checked on the vehicle's spawn brick. Base colors are unavailable.");
            }

            if(%arg1 > 0 && %arg1 <= %this.numFactoryColors[%factoryColorGroup])
            {
                return %veh.setNodeColor("ALL", getColorF(getWord(%this.factoryColor[%factoryColorGroup, %arg1], 0)));
            }

            else if(%arg1 == 0 && %veh.colorSchemeTarget != 0)
            {
                return sharkIIVehicle.deleteCurrentPaintTarget(%veh, %c, %vehname);
            }
            
            else
            {
                %c.chatMessage(%vehname @ "That is not a valid factory color for \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget]);
                sharkIIvehicle.displayFactoryColorString(%veh, %c);
                return;
            }
        }

        // if(%arg1 $= "s")
        // {
        //  if(strlen(%veh.colorSchemeNodes[1]) != 0 && getWord(%veh.colorSchemeColor[1], 3) == 1)//active
        //  {
        //      %c.chatMessage(%vehname @ "Hood stripe removed.");
        //      %restoretarget = %veh.colorSchemeTarget;
        //      %veh.colorSchemeTarget = 0;
        //      %veh.colorSchemeColor[1] = "0 0 0 0";
        //      %brick.colorSchemeColor[%ID, 1] = "0 0 0 0";
        //      %veh.setNodeColor("ALL", %veh.colorSchemeColor[0]);
        //      %veh.colorSchemeTarget = %restoretarget;

        //      if(%veh.colorSchemeTarget == 1)
        //      {
        //          %veh.colorSchemeTarget = 0;
        //          %c.chatMessage(%vehname @ "Paint target changed to \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget]);

        //          sharkIIvehicle.displayFactoryColorString(%veh, %c);
                    
        //          sharkIIvehicle.displayColorTargets(%veh, %c);

        //          return;
        //      }
        //  }

        //  return;
        // }
        if(%arg1 $= "t")
        {
            if(%arg2 $="")
            {
                %proposedtarget = %veh.colorSchemeTarget + 1;
                if(%proposedtarget >= %veh.numColorSchemeTargets)
                    %proposedtarget = 0;
            }
            else if(%arg2 < 0 || %arg2 >= %veh.numColorSchemeTargets || !strIsNum(%arg2))
            {
                return %c.chatmessage(%vehname @ "That is not a valid color scheme number.");
            }
            else
            {
                %proposedtarget = mFloor(%arg2);
            }

            %veh.colorSchemeTarget = %proposedTarget;
            %c.chatMessage(%vehname @ "Paint target changed to \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget]);

            if(!%c.VEH3argHintGiven)
            {
                %c.chatMessage("\c2One-time hint\c6: If you type a third argument, like \c4/veh t 2 3\c6 or \c4/veh t 2 c\c6, you can apply or view factory colors immediately after changing targets.");
                %c.VEH3argHintGiven = true;
            }

            sharkIIvehicle.displayFactoryColorString(%veh, %c);
            
            sharkIIvehicle.displayColorTargets(%veh, %c);

            if(%arg3 $= "c")
            {
                %c.VEHactivationTimer = %c.VEHactivationTimer - 1000;
                sharkIIvehicle.VehicleEditHelper(%veh, %c, "c");
            }

            if(strIsNum(%arg3)) //Apply factory colors
            {
                ///

                // if(strIsNum(%arg2) && %arg2 >= 0 && %arg2 < %veh.numFactoryColorGroups)
                // {
                //  %factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%arg2];
                // }
                // else
                // {
                    %factoryColorGroup = %veh.colorSchemeFactoryColorGroup[%veh.colorSchemeTarget];
                // }

                ///

                if(%arg3 > 0 && %arg3 <= %this.numFactoryColors[%factoryColorGroup])
                {
                    return %veh.setNodeColor("ALL", getColorF(getWord(%this.factoryColor[%factoryColorGroup, %arg3], 0)));
                }

                else if(%arg3 == 0 && %veh.colorSchemeTarget != 0)
                {
                    return sharkIIVehicle.deleteCurrentPaintTarget(%veh, %c, %vehname);
                }
                
                else
                {
                    %c.chatMessage(%vehname @ "That is not a valid factory color for \c4" @ %veh.colorSchemeTarget @ ": \c3" @ %veh.colorSchemeName[%veh.colorSchemeTarget]);
                    sharkIIvehicle.displayFactoryColorString(%veh, %c);
                    return;
                }
            }

            return;
        }
    // }



    %c.chatMessage("\c8-----\c0Shark II \c6(AKA Corvette C3)\c8 - \c0Vehicle Edit Helper\c8-----");
    %c.chatMessage("        <color:8888AA>Shift brick <color:FFAA00>LEFT / RIGHT:<color:FFDD88> Turn signals; <color:8888AA>Shift brick <color:FFAA00>DOWN: <color:FFDD88>Hazard lights");
    %c.chatMessage("        \c7/veh \c1P \c8- \c6Expanded \c1visual parts\c6 list for customization!");

    // if(0)//%brick.reColorVehicle)
    // {
    //  %c.chatMessage("    \c3This car's spawn brick has Re-Color Vehicle checked. Colors are locked!");
    // }
    // else
    // {
        // %c.chatMessage("        \c0C \c3# \c8- \c6View factory colors; \c0# \c3# \c8- \c6Apply factory color. Include \c3# \c6to change paint target.");
        %c.chatMessage("        \c7/veh \c2RA \c8- \c6Randomize factory colors on all parts!");
        %c.chatMessage("        \c7/veh \c0# \c8- \c6Apply \c0factory color \c7/veh \c0C \c8- \c6View \c0factory colors\c6 and names for current paint target.");
        if(%veh.colorSchemeTarget != 0 && strlen(%veh.colorSchemeNodes[%veh.colorSchemeTarget]) != 0 && getWord(%veh.colorSchemeColor[%veh.colorSchemeTarget], 3) == 1)
        {
        %c.chatMessage("        \c00 \c8- \c6Remove current paint target's color (match base color)");
        }
        sharkIIvehicle.displayFactoryColorString(%veh, %c);
        %c.chatMessage("        \c7/veh \c4T \c8- \c6Cycle paint target.");
        sharkIIvehicle.displayColorTargets(%veh, %c);
    // }
}