function sharkIIvehicle::onTrigger(%this, %veh, %slot, %val)	//Braking
{
	if(%val)
	{	//brake on
		%veh.braking = 1;

		//If a signal is on, that side will be left alone

		if(%veh.signal == -1)		//Don't touch the taillight if the turn signal is on
		{
			%veh.partsBot.hidenode(lights_brakeR0);
			%veh.partsBot.hidenode(lights_brakeR1);
			%veh.partsBot.unhidenode(lights_brakeR2);
		}
		else if(%veh.signal == 1)
		{
			%veh.partsBot.hidenode(lights_brakeL0);
			%veh.partsBot.hidenode(lights_brakeL1);
			%veh.partsBot.unhidenode(lights_brakeL2);
		}
		else if(%veh.signal == 0)
		{
			%veh.partsBot.hidenode(lights_brakeR0);
			%veh.partsBot.hidenode(lights_brakeR1);
			%veh.partsBot.unhidenode(lights_brakeR2);
			%veh.partsBot.hidenode(lights_brakeL0);
			%veh.partsBot.hidenode(lights_brakeL1);
			%veh.partsBot.unhidenode(lights_brakeL2);
		}
	}
	else
	{	//brake off
		%veh.braking = 0;


		if(%veh.signal == -1)
		{
			%veh.partsBot.hidenode(lights_brakeR2);

			if(%veh.headlightState == 0)
				%veh.partsBot.unhidenode(lights_brakeR0);

			else
				%veh.partsBot.unhidenode(lights_brakeR1);
		}
		else if(%veh.signal == 1)
		{
			%veh.partsBot.hidenode(lights_brakeL2);

			if(%veh.headlightState == 0)
				%veh.partsBot.unhidenode(lights_brakeL0);

			else
				%veh.partsBot.unhidenode(lights_brakeL1);
		}
		else if(%veh.signal == 0)
		{
			%veh.partsBot.hidenode(lights_brakeR2);

			if(%veh.headlightState == 0)
				%veh.partsBot.unhidenode(lights_brakeR0);

			else
				%veh.partsBot.unhidenode(lights_brakeR1);


			%veh.partsBot.hidenode(lights_brakeL2);

			if(%veh.headlightState == 0)
				%veh.partsBot.unhidenode(lights_brakeL0);

			else
				%veh.partsBot.unhidenode(lights_brakeL1);
		}
	}
}

function sharkIIvehicle::headlights(%this, %veh, %directive, %selection)
{
	switch$(%directive)
	{
		case "next":
		%setlights = %veh.headlightState + 1;
		%veh.headlightState = %veh.headlightState + 1;
		
		case "restore":
		%setlights = %veh.headlightState;
		
		case "select":
		%setlights = %selection;
		%veh.headlightState = %selection;
		
		case "off":
		%setlights = 0;
	}
	
	if(%setlights > 3)
	{
		%setlights = 0;
		%veh.headlightState = 0;
	}

	if(%veh.visPart["headlight"] == 0)
	{
		%headlight = %veh;

		%veh.partsBot.hidenode(headlightsL0);
		%veh.partsBot.hidenode(headlightsR0);
		%veh.partsBot.hidenode(headlightsL1);
		%veh.partsBot.hidenode(headlightsR1);
		%veh.partsBot.hidenode(headlightsL2);
		%veh.partsBot.hidenode(headlightsR2);
	}
	else if(%veh.visPart["headlight"] == 1)
	{
		%headlight = %veh.partsBot;

		%veh.hidenode(headlightsL0);
		%veh.hidenode(headlightsR0);
		%veh.hidenode(headlightsL1);
		%veh.hidenode(headlightsR1);
		%veh.hidenode(headlightsL2);
		%veh.hidenode(headlightsR2);
	}
				
	if(%veh.visPart["bumper"] == 0)
	{
		%veh.partsBot.hidenode(lights_idlesignal75L0);
		%veh.partsBot.hidenode(lights_idlesignal75R0);
		%veh.partsBot.hidenode(lights_idlesignal75L1);
		%veh.partsBot.hidenode(lights_idlesignal75R1);
	}
	
	switch(%setlights)
	{
		case 0:		//Headlights off
			%veh.mountedLightBot[2].setMountedLight(none);

			%veh.partsBot.unhidenode(lights_dash0);
			%veh.partsBot.hidenode(lights_dash1);

        	if(%veh.lightsup)
        	{
        		%veh.playThread(0, lightsdown);
        		%veh.lightsup = false;
        	}

			%headlight.unhidenode(headlights @ %type @ L0);
			%headlight.unhidenode(headlights @ %type @ R0);

			%headlight.hidenode(headlights @ %type @ L1);
			%headlight.hidenode(headlights @ %type @ R1);
			%headlight.hidenode(headlights @ %type @ L2);
			%headlight.hidenode(headlights @ %type @ R2);

			if(%veh.signal == 0)
			{
				%veh.partsBot.unhidenode(lights_idlesignalL0);
				%veh.partsBot.unhidenode(lights_idlesignalR0);
				%veh.partsBot.hidenode(lights_idlesignalL1);
				%veh.partsBot.hidenode(lights_idlesignalR1);

				if(%veh.visPart["bumper"] != 0)
				{
					%veh.partsBot.unhidenode(lights_idlesignal75L0);
					%veh.partsBot.unhidenode(lights_idlesignal75R0);
					%veh.partsBot.hidenode(lights_idlesignal75L1);
					%veh.partsBot.hidenode(lights_idlesignal75R1);
				}
				// %veh.partsBot.unhidenode(lights_signalL0);
				// %veh.partsBot.unhidenode(lights_signalR0);
				// %veh.partsBot.hidenode(lights_signalL1);
				// %veh.partsBot.hidenode(lights_signalR1);
			}
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR1);
					%veh.partsBot.unhidenode(lights_brakeR0);
				}
				if(%veh.signal == 1)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL1);
					%veh.partsBot.unhidenode(lights_brakeL0);
				}
				if(%veh.signal == 0)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL1);
					%veh.partsBot.unhidenode(lights_brakeL0);
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR1);
					%veh.partsBot.unhidenode(lights_brakeR0);
				}
			}
		
		case 1:		//Daytime-running lights
			%veh.mountedLightBot[2].setMountedLight(none);

			%veh.partsBot.unhidenode(lights_dash1);
			%veh.partsBot.hidenode(lights_dash0);

        	if(%veh.lightsup)
        	{
        		%veh.playThread(0, lightsdown);
        		%veh.lightsup = false;
        	}

			%headlight.unhidenode(headlights @ %type @ L0);
			%headlight.unhidenode(headlights @ %type @ R0);

			%headlight.hidenode(headlights @ %type @ L1);
			%headlight.hidenode(headlights @ %type @ R1);
			%headlight.hidenode(headlights @ %type @ L2);
			%headlight.hidenode(headlights @ %type @ R2);

			if(%veh.signal == 0)
			{
				%veh.partsBot.hidenode(lights_idlesignalL0);
				%veh.partsBot.hidenode(lights_idlesignalR0);
				// %veh.partsBot.hidenode(lights_signalL0);
				// %veh.partsBot.hidenode(lights_signalR0);

				%veh.partsBot.unhidenode(lights_idlesignalL1);
				%veh.partsBot.unhidenode(lights_idlesignalR1);
				// %veh.partsBot.unhidenode(lights_signalL1);
				// %veh.partsBot.unhidenode(lights_signalR1);
				
				if(%veh.visPart["bumper"] != 0)
				{
					%veh.partsBot.hidenode(lights_idlesignal75L0);
					%veh.partsBot.hidenode(lights_idlesignal75R0);
					%veh.partsBot.unhidenode(lights_idlesignal75L1);
					%veh.partsBot.unhidenode(lights_idlesignal75R1);
				}
			}
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR0);
					%veh.partsBot.unhidenode(lights_brakeR1);
				}
				if(%veh.signal == 1)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL0);
					%veh.partsBot.unhidenode(lights_brakeL1);
				}
				if(%veh.signal == 0)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL0);
					%veh.partsBot.unhidenode(lights_brakeL1);
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR0);
					%veh.partsBot.unhidenode(lights_brakeR1);
				}
			}
		
		case 2:		//HEADLIGHTS GO UP!
			%veh.mountedLightBot[2].setMountedLight(none);

			%veh.partsBot.unhidenode(lights_dash1);
			%veh.partsBot.hidenode(lights_dash0);

        	if(!%veh.lightsup)
        	{
        		%veh.playThread(0, lightsup);
        		%veh.lightsup = true;
        	}

			%headlight.hidenode(headlights @ %type @ L0);
			%headlight.hidenode(headlights @ %type @ R0);

			%headlight.unhidenode(headlights @ %type @ L1);
			%headlight.unhidenode(headlights @ %type @ R1);

			%headlight.hidenode(headlights @ %type @ L2);
			%headlight.hidenode(headlights @ %type @ R2);

			if(%veh.signal == 0)
			{
				%veh.partsBot.hidenode(lights_idlesignalL0);
				%veh.partsBot.hidenode(lights_idlesignalR0);
				// %veh.partsBot.hidenode(lights_signalL0);
				// %veh.partsBot.hidenode(lights_signalR0);

				%veh.partsBot.unhidenode(lights_idlesignalL1);
				%veh.partsBot.unhidenode(lights_idlesignalR1);
				// %veh.partsBot.unhidenode(lights_signalL1);
				// %veh.partsBot.unhidenode(lights_signalR1);
				
				if(%veh.visPart["bumper"] != 0)
				{
					%veh.partsBot.hidenode(lights_idlesignal75L0);
					%veh.partsBot.hidenode(lights_idlesignal75R0);
					%veh.partsBot.unhidenode(lights_idlesignal75L1);
					%veh.partsBot.unhidenode(lights_idlesignal75R1);
				}
			}
			
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR0);
					%veh.partsBot.unhidenode(lights_brakeR1);
				}
				if(%veh.signal == 1)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL0);
					%veh.partsBot.unhidenode(lights_brakeL1);
				}
				if(%veh.signal == 0)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL0);
					%veh.partsBot.unhidenode(lights_brakeL1);
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR0);
					%veh.partsBot.unhidenode(lights_brakeR1);
				}
			}
		
		case 3:		//Full lights including light source
			%veh.mountedLightBot[2].setMountedLight(sharkIIHeadLight);

			%veh.partsBot.unhidenode(lights_dash1);
			%veh.partsBot.hidenode(lights_dash0);

        	if(!%veh.lightsup)
        	{
        		%veh.playThread(0, lightsup);
        		%veh.lightsup = true;
        	}

			%headlight.hidenode(headlights @ %type @ L0);
			%headlight.hidenode(headlights @ %type @ R0);
			%headlight.hidenode(headlights @ %type @ L1);
			%headlight.hidenode(headlights @ %type @ R1);
			
			%headlight.unhidenode(headlights @ %type @ L2);
			%headlight.unhidenode(headlights @ %type @ R2);

			if(%veh.signal == 0)
			{
				%veh.partsBot.hidenode(lights_idlesignalL0);
				%veh.partsBot.hidenode(lights_idlesignalR0);
				// %veh.partsBot.hidenode(lights_signalL0);
				// %veh.partsBot.hidenode(lights_signalR0);

				%veh.partsBot.unhidenode(lights_idlesignalL1);
				%veh.partsBot.unhidenode(lights_idlesignalR1);
				// %veh.partsBot.unhidenode(lights_signalL1);
				// %veh.partsBot.unhidenode(lights_signalR1);
				
				if(%veh.visPart["bumper"] != 0)
				{
					%veh.partsBot.hidenode(lights_idlesignal75L0);
					%veh.partsBot.hidenode(lights_idlesignal75R0);
					%veh.partsBot.unhidenode(lights_idlesignal75L1);
					%veh.partsBot.unhidenode(lights_idlesignal75R1);
				}
			}
			
			
			if(!%veh.braking)	//Leave brake lights alone if currently braking
			{
				if(%veh.signal == -1)
				{
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR0);
					%veh.partsBot.unhidenode(lights_brakeR1);
				}
				if(%veh.signal == 1)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL0);
					%veh.partsBot.unhidenode(lights_brakeL1);
				}
				if(%veh.signal == 0)
				{
					%veh.partsBot.hidenode(lights_brakeL2);
					%veh.partsBot.hidenode(lights_brakeL0);
					%veh.partsBot.unhidenode(lights_brakeL1);
					%veh.partsBot.hidenode(lights_brakeR2);
					%veh.partsBot.hidenode(lights_brakeR0);
					%veh.partsBot.unhidenode(lights_brakeR1);
				}
			}
	}
} //End of headlights


/////////////////////////////////////////////////////////////////////////////////


function sharkIIvehicle::turnSignal(%this, %veh, %direction)
{
	if (!isObject(%veh)) return;
	//announce("turnSignal with direction " @ %direction @ " and signalMinor " @ %veh.signalMinor);

	if(%direction == 0 || %direction != %veh.signal)	//0 is a signal to turn off
	{	//TURN OFF SIGNAL
		cancel(%veh.turnSignalSchedule);
		%veh.signalMinor = 0;	//this means lights will begin on "turn on" cycle when next used

		if(%veh.braking)				//If the car is braking, return taillights to bright red
		{
			%veh.partsBot.hidenode(lights_brakeR0);
			%veh.partsBot.hidenode(lights_brakeL0);
			%veh.partsBot.hidenode(lights_brakeR1);
			%veh.partsBot.hidenode(lights_brakeL1);
			%veh.partsBot.unhidenode(lights_brakeR2);
			%veh.partsBot.unhidenode(lights_brakeL2);
		}
		else if(%veh.headlightState == 0)	//If no brakes and lights are off, return taillights to completely off
		{
			%veh.partsBot.unhidenode(lights_brakeR0);
			%veh.partsBot.unhidenode(lights_brakeL0);
			%veh.partsBot.hidenode(lights_brakeR1);
			%veh.partsBot.hidenode(lights_brakeL1);
			%veh.partsBot.hidenode(lights_brakeR2);
			%veh.partsBot.hidenode(lights_brakeL2);
		}
		else							//If no brakes and lights are on, return taillights to dim red
		{
			%veh.partsBot.hidenode(lights_brakeR0);
			%veh.partsBot.hidenode(lights_brakeL0);
			%veh.partsBot.unhidenode(lights_brakeR1);
			%veh.partsBot.unhidenode(lights_brakeL1);
			%veh.partsBot.hidenode(lights_brakeR2);
			%veh.partsBot.hidenode(lights_brakeL2);
		}

		if(%veh.headlightState == 0)
		{
			%veh.partsBot.unhideNode(lights_idlesignalR0);
			%veh.partsBot.unhideNode(lights_idlesignalL0);
			%veh.partsBot.hideNode(lights_idlesignalR1);
			%veh.partsBot.hideNode(lights_idlesignalL1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.unhidenode(lights_idlesignal75L0);
				%veh.partsBot.unhidenode(lights_idlesignal75R0);
				%veh.partsBot.hidenode(lights_idlesignal75L1);
				%veh.partsBot.hidenode(lights_idlesignal75R1);
			}

			// %veh.partsBot.unhideNode(lights_signalR0);
			// %veh.partsBot.unhideNode(lights_signalL0);
			// %veh.partsBot.hideNode(lights_signalR1);
			// %veh.partsBot.hideNode(lights_signalL1);
		}
		else
		{
			%veh.partsBot.hideNode(lights_idlesignalR0);
			%veh.partsBot.hideNode(lights_idlesignalL0);
			%veh.partsBot.unhideNode(lights_idlesignalR1);
			%veh.partsBot.unhideNode(lights_idlesignalL1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.hidenode(lights_idlesignal75L0);
				%veh.partsBot.hidenode(lights_idlesignal75R0);
				%veh.partsBot.unhidenode(lights_idlesignal75L1);
				%veh.partsBot.unhidenode(lights_idlesignal75R1);
			}

			// %veh.partsBot.hideNode(lights_signalR0);
			// %veh.partsBot.hideNode(lights_signalL0);
			// %veh.partsBot.unhideNode(lights_signalR1);
			// %veh.partsBot.unhideNode(lights_signalL1);
		}
	}	//END OF TURN OFF SIGNAL

	%veh.signal = %direction;	//Other functions must know which direction is being used
	if(%direction == 0)	return;



	if(%veh.signalMinor == 0)	//If the signal lights were off before this moment. Turn on
	{
		%veh.signalMinor = 1;	//Switch so that the schedule uses the section below
		if(%direction == 1)		//Right side turn on
		{
			// %veh.partsBot.hideNode(lights_signalR0);
			// %veh.partsBot.unhideNode(lights_signalR1);
			%veh.partsBot.hideNode(lights_idlesignalR0);
			%veh.partsBot.unhideNode(lights_idlesignalR1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.hidenode(lights_idlesignal75R0);
				%veh.partsBot.unhidenode(lights_idlesignal75R1);
			}

			%veh.partsBot.hideNode(lights_brakeR0);
			%veh.partsBot.hideNode(lights_brakeR1);
			%veh.partsBot.unhideNode(lights_brakeR2);
		}
		else if(%direction == -1)	//Left side turn on
		{
			// %veh.partsBot.hideNode(lights_signalL0);
			// %veh.partsBot.unhideNode(lights_signalL1);
			%veh.partsBot.hideNode(lights_idlesignalL0);
			%veh.partsBot.unhideNode(lights_idlesignalL1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.hidenode(lights_idlesignal75L0);
				%veh.partsBot.unhidenode(lights_idlesignal75L1);
			}

			%veh.partsBot.hideNode(lights_brakeL0);
			%veh.partsBot.hideNode(lights_brakeL1);
			%veh.partsBot.unhideNode(lights_brakeL2);
		}
		else //Hazard lights on
		{
			// %veh.partsBot.hideNode(lights_signalR0);
			// %veh.partsBot.unhideNode(lights_signalR1);
			%veh.partsBot.hideNode(lights_idlesignalR0);
			%veh.partsBot.unhideNode(lights_idlesignalR1);
			// %veh.partsBot.hideNode(lights_signalL0);
			// %veh.partsBot.unhideNode(lights_signalL1);
			%veh.partsBot.hideNode(lights_idlesignalL0);
			%veh.partsBot.unhideNode(lights_idlesignalL1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.hidenode(lights_idlesignal75L0);
				%veh.partsBot.hidenode(lights_idlesignal75R0);
				%veh.partsBot.unhidenode(lights_idlesignal75L1);
				%veh.partsBot.unhidenode(lights_idlesignal75R1);
			}

			%veh.partsBot.hideNode(lights_brakeR0);
			%veh.partsBot.hideNode(lights_brakeR1);
			%veh.partsBot.unhideNode(lights_brakeR2);

			%veh.partsBot.hideNode(lights_brakeL0);
			%veh.partsBot.hideNode(lights_brakeL1);
			%veh.partsBot.unhideNode(lights_brakeL2);
		}
	}
	else	//Signal lights were on before this instant. Turn off
	{
		%veh.signalMinor = 0;	//Switch so that the schedule uses the section above
		if(%direction == 1)		//Right side turn off
		{
			%veh.partsBot.unhideNode(lights_idlesignalR0);
			%veh.partsBot.hideNode(lights_idlesignalR1);
			// %veh.partsBot.unhideNode(lights_signalR0);
			// %veh.partsBot.hideNode(lights_signalR1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.unhidenode(lights_idlesignal75R0);
				%veh.partsBot.hidenode(lights_idlesignal75R1);
			}

			%veh.partsBot.hideNode(lights_brakeR2);
			if(%veh.headlightState > 0) %veh.partsBot.unhideNode(lights_brakeR1);
			else                        %veh.partsBot.unhideNode(lights_brakeR0);
		}
		else if(%direction == -1)	//Left side turn off
		{
			%veh.partsBot.unhideNode(lights_idlesignalL0);
			%veh.partsBot.hideNode(lights_idlesignalL1);
			// %veh.partsBot.unhideNode(lights_signalL0);
			// %veh.partsBot.hideNode(lights_signalL1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.unhidenode(lights_idlesignal75L0);
				%veh.partsBot.hidenode(lights_idlesignal75L1);
			}

			%veh.partsBot.hideNode(lights_brakeL2);
			if(%veh.headlightState > 0) %veh.partsBot.unhideNode(lights_brakeL1);
			else						%veh.partsBot.unhideNode(lights_brakeL0);
		}
		else //Hazard lights off
		{
			%veh.partsBot.unhideNode(lights_idlesignalR0);
			%veh.partsBot.hideNode(lights_idlesignalR1);
			// %veh.partsBot.unhideNode(lights_signalR0);
			// %veh.partsBot.hideNode(lights_signalR1);
			%veh.partsBot.unhideNode(lights_idlesignalL0);
			%veh.partsBot.hideNode(lights_idlesignalL1);
			// %veh.partsBot.unhideNode(lights_signalL0);
			// %veh.partsBot.hideNode(lights_signalL1);
				
			if(%veh.visPart["bumper"] != 0)
			{
				%veh.partsBot.unhidenode(lights_idlesignal75L0);
				%veh.partsBot.unhidenode(lights_idlesignal75R0);
				%veh.partsBot.hidenode(lights_idlesignal75L1);
				%veh.partsBot.hidenode(lights_idlesignal75R1);
			}

			%veh.partsBot.hideNode(lights_brakeR2);
			%veh.partsBot.hideNode(lights_brakeL2);
			if(%veh.headlightState > 0)
			{
				%veh.partsBot.unhideNode(lights_brakeR1);
				%veh.partsBot.unhideNode(lights_brakeL1);
			}
			else
			{
				%veh.partsBot.unhideNode(lights_brakeR0);
				%veh.partsBot.unhideNode(lights_brakeL0);
			}
		}
	}
		
	return %veh.turnSignalSchedule = %this.schedule(320, turnSignal, %veh, %direction);
}