package sharkIIPackage
{
    function sharkIIVehicle::onAdd(%this, %veh)
    {
        Parent::onAdd(%this, %veh);

        // %veh.spawnSharkIIMountedLightBot(2);
        %veh.partsBot = %veh.spawnSharkIIMountedLightBot(2);

        %veh.playThread(0, lightsroot);
        %veh.playThread(1, ttopup);
        
        %veh.setWheelPowered(0, 0);
        %veh.setWheelPowered(1, 0);

        // %veh.setWheelSpring(0, sharkIIfrontspring);
        // %veh.setWheelSpring(1, sharkIIfrontspring);

        %veh.hidenode(headlightsL1);
        %veh.hidenode(headlightsL2);
        %veh.hidenode(headlightsR1);
        %veh.hidenode(headlightsR2);
        %veh.partsBot.hidenode(headlightsL1);
        %veh.partsBot.hidenode(headlightsL2);
        %veh.partsBot.hidenode(headlightsR1);
        %veh.partsBot.hidenode(headlightsR2);
        %veh.partsBot.hidenode(lights_dash1);
        %veh.partsBot.hidenode(lights_idlesignalR1);
        %veh.partsBot.hidenode(lights_idlesignalL1);
        %veh.partsBot.hidenode(lights_brakeR1);
        %veh.partsBot.hidenode(lights_brakeR2);
        %veh.partsBot.hidenode(lights_brakeL1);
        %veh.partsBot.hidenode(lights_brakeL2);
        %veh.partsBot.hidenode(lights_reverse1);
        // %veh.hidenode(lights_signalR1);
        // %veh.hidenode(lights_signalL1);

        %veh.colorSchemeTarget = 0;

        %this.schedule(100, loadSpawnBrickAttributes, %veh);
    }

    function sharkIIvehicle::setDefaultBrickAttributes(%this, %veh)
    {
        //announce("Setting random values.");

        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        %brick.numColorSchemeTargets[%ID] = 9;

        %a = getRandom(%this.numFactoryColors[0] - 1) + 1;

        %brick.colorSchemeName[%ID, 0] = "Base"; //base colorSchemeNodes are not defined, as it is "everything else"
        %brick.colorSchemeFactoryColorGroup[%ID, 0] = 0;
        %brick.colorSchemeColor[%ID, 0] = getColorF(getWord(%this.factoryColor[0, %a], 0));


        %brick.colorSchemeName[%ID, 1] = "Stripe";
        %brick.colorSchemeNodes[%ID, 1] = "h69str h70str h72str h75str";
        %brick.colorSchemeFactoryColorGroup[%ID, 1] = 3;

        if((%brick.visPart["hood", %ID] == 1 && getRandom() < 1) || %brick.visPart["hood", %ID] == 0 || %brick.visPart["stripe", %ID] > 0)
        { //75% chance to have a hood stripe, 0% chance if hood is sleek, 100% chance if hood is modified
            if(%a==6||%a==7||%a==8||%a==9||%a==11||%a==14||%a==16||%a==18||%a==22||%a==23) //white
            {
                %b = 2;
            }
            else //black
            {
                %b = 1;
            }
            %hoodstripe = getColorF(getWord(%this.factoryColor[3, %b], 0));
            //announce(%hoodstripe);
        }
        else
        {
            %hoodstripe = "0 0 0 0"; 
        }
        %brick.colorSchemeColor[%ID, 1] = %hoodstripe;


        %brick.colorSchemeName[%ID, 2] = "Interior";
        %brick.colorSchemeNodes[%ID, 2] = "int rcoupeint rhtopint rttopsint rwagonint";
        %brick.colorSchemeFactoryColorGroup[%ID, 2] = 1;

        // announce("%a = " @ %a);

        %selection = getRandom(getWordCount(%this.factoryColorSuggestedInterior[%a]) - 1);
        
        %interiorColor = getWord(%this.factoryColorSuggestedInterior[%a], %selection); //oh my god.

        // announce("Interior color is " @ %selection+1 @ " out of "@ getWordCount(%this.factoryColorSuggestedInterior[%a]));

        %brick.colorSchemeColor[%ID, 2] = getColorF(getWord(%this.factoryColor[1, %interiorColor], 0));
        // announce("Interior: - " @ %interiorcolor @ " - <color:" @ getWord(%this.factoryColor[1, %interiorColor], 0) @ ">" @ getWord(%this.factoryColor[1, %interiorColor], 1));

        %brick.colorSchemeName[%ID, 3] = "Interior trim";
        %brick.colorSchemeNodes[%ID, 3] = "intstuff";
        %brick.colorSchemeFactoryColorGroup[%ID, 3] = 1;
        %brick.colorSchemeColor[%ID, 3] = "0 0 0 0";
        %brick.colorSchemeDefault[%ID, 3] = 2;
        // announce("Panel: - " @ %doorpanelthing @ " - <color:" @ getWord(%this.factoryColor[1, %doorpanelthing], 0) @ ">" @ getWord(%this.factoryColor[1, %doorpanelthing], 1));

        %brick.colorSchemeName[%ID, 4] = "Center console";
        %brick.colorSchemeNodes[%ID, 4] = "intcent";
        %brick.colorSchemeFactoryColorGroup[%ID, 4] = 1;
        %brick.colorSchemeColor[%ID, 4] = getColorF(getWord(%this.factoryColor[1, 1], 0));
        %brick.colorSchemeDefault[%ID, 4] = 2;

        %brick.colorSchemeName[%ID, 5] = "Steering wheel";
        %brick.colorSchemeNodes[%ID, 5] = "steer";
        %brick.colorSchemeFactoryColorGroup[%ID, 5] = 1;
        %brick.colorSchemeColor[%ID, 5] = getColorF(getWord(%this.factoryColor[1, 1], 0));
        %brick.colorSchemeDefault[%ID, 5] = 2;

        %brick.colorSchemeName[%ID, 6] = "Metal trim";
        %brick.colorSchemeNodes[%ID, 6] = "bodymet steermet rcoupemet s70met s70rmet exside exrec ex75 vent69met vent70met rack";
        %brick.colorSchemeFactoryColorGroup[%ID, 6] = 2;
        %brick.colorSchemeColor[%ID, 6] = getColorF(getWord(%this.factoryColor[2, 1], 0));

        %brick.colorSchemeName[%ID, 7] = "Lower half";
        %brick.colorSchemeNodes[%ID, 7] = "bodylow vent69 vent70 vent75 s75flow s75rlow s70flow s70rlow excovers";
        %brick.colorSchemeFactoryColorGroup[%ID, 7] = 0;
        %brick.colorSchemeColor[%ID, 7] = "0 0 0 0";

        %brick.colorSchemeName[%ID, 8] = "Wheel arches";
        %brick.colorSchemeNodes[%ID, 8] = "arches arches70 arches69 archeswide";
        %brick.colorSchemeFactoryColorGroup[%ID, 8] = 0;
        %brick.colorSchemeColor[%ID, 8] = "0 0 0 0";

        %brick.carAttributesSet[%ID] = true;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);
        //%this.loadSpawnBrickAttributes(%veh);

        return;
    }

    function sharkIIvehicle::loadSpawnBrickAttributes(%this, %veh)
    {
        // announce("load attributes " @ %this);
        %brick = %veh.spawnbrick;
        %ID = %this.colorSchemeIdentifier;

        if(!%brick.carAttributesSet[%ID]) //If the car has never been spawned before, randomize some specific visual elements.
        {
            %brick.visPart["roof", %ID] = getRandom() < 0.35; //35% chance to be convertible
            %brick.visPart["roofcover", %ID] = getRandom() < 0.3; //30% chance to have top down
            %brick.visPartManuallySet["roof", %ID] = true; //Not really manually set, but this way it won't be reverted when spawning a different variant.
            %brick.visPartManuallySet["roofcover", %ID] = true;
            %brick.visPart["hood", %ID] = %this.visPartDefault["hood"]; //I'm putting this here so that it knows what to do with the stripe the first time
            return %this.setDefaultBrickAttributes(%veh);
        }

        for(%i = 0; %i < getWordCount(%this.visPartsList); %i++) //If the user never manually changed these parts, set them to their default appearance for the car.
        { //These need to be changed if another variant had been spawned and was using a different set of default visual parts.
            %part = getWord(%this.visPartsList, %i);
            if(!%brick.visPartManuallySet[%part, %ID])
                %brick.visPart[%part, %ID] = %this.visPartDefault[%part];
        }

        for(%i = 0; %i < getWordCount(%this.visPartsList); %i++) //Apply the values on the brick to the car.
        {
            %part = getWord(%this.visPartsList, %i);
            %veh.visPart[%part] = %brick.visPart[%part, %ID];
        }


        %veh.numColorSchemeTargets = %brick.numColorSchemeTargets[%ID]; //Apply color-related traits to the car itself, as saved on the brick

        for(%i = 0; %i < %brick.numColorSchemeTargets[%ID]; %i++)
        {
            //announce(%brick.colorSchemeName[%this, %i]);
            %veh.colorSchemeName[%i] = %brick.colorSchemeName[%ID, %i];
            if(%i > 0) 
            {
                %veh.colorSchemeNodes[%i] = %brick.colorSchemeNodes[%ID, %i];
                %veh.colorSchemeDefault[%i] = %brick.colorSchemeDefault[%ID, %i];
            }
            %veh.colorSchemeFactoryColorGroup[%i] = %brick.colorSchemeFactoryColorGroup[%ID, %i];
            %veh.colorSchemeColor[%i] = %brick.colorSchemeColor[%ID, %i];
        }

        switch(%brick.wheelCurrent[%ID])
        {
            case 0:
                //Do nothing.

            case 1:
                %veh.setWheelTire(0, sharkIItire);
                %veh.setWheelTire(1, sharkIItire);
                %veh.setWheelTire(2, sharkIItire);
                %veh.setWheelTire(3, sharkIItire);

            case 2:
                %veh.setWheelTire(0, sharkIIlinetire);
                %veh.setWheelTire(1, sharkIIlinetire);
                %veh.setWheelTire(2, sharkIIlinetire);
                %veh.setWheelTire(3, sharkIIlinetire);

            case 3:
                %veh.setWheelTire(0, sharkIIredlinetire);
                %veh.setWheelTire(1, sharkIIredlinetire);
                %veh.setWheelTire(2, sharkIIredlinetire);
                %veh.setWheelTire(3, sharkIIredlinetire);

            case 4:
                %veh.setWheelTire(0, sharkIIfivespoke255tire);
                %veh.setWheelTire(1, sharkIIfivespoke255tire);
                %veh.setWheelTire(2, sharkIIfivespoke255tire);
                %veh.setWheelTire(3, sharkIIfivespoke255tire);

            case 5:
                %veh.setWheelTire(0, sharkIIfivespoke255tire);
                %veh.setWheelTire(1, sharkIIfivespoke255tire);
                %veh.setWheelTire(2, sharkIIfivespoke355tire);
                %veh.setWheelTire(3, sharkIIfivespoke355tire);
        }

        %this.applyParts(%veh); //Apply all hidden/unhidden nodes
        
        %colorSchemeTargetRestore = %veh.colorSchemeTarget;
        %veh.colorSchemeTarget = 0;
        if(%brick.reColorVehicle)
            %brick.colorVehicle();
        else
            %veh.setNodeColor("ALL", %veh.colorSchemeColor[0]); //Reapply current color to cause changes
        %veh.colorSchemeTarget = %colorSchemeTargetRestore;
    }

    // function sharkIIvehicle::saveSpawnBrickAttributes(%this, %veh)
    // {
    //     %brick = %veh.spawnbrick;
    //     announce("Saving attributes to brick.");
    //     %brick.hoodtype[%this] = %veh.hoodtype;
    //     %brick.rooftype[%this] = %veh.rooftype;
    //     %brick.roofcover[%this] = %veh.roofcover;

    //     %brick.numColorSchemeTargets[%this] = %veh.numColorSchemeTargets;
    //     for(%i = 0; %i < %veh.numColorSchemeTargets; %i++)
    //     {
    //         //announce("Saving " @ mceil((%i+1) / (%veh.numColorSchemeTargets+1) * 100) @ "%");
    //         %brick.colorSchemeName[%this, %i] = %veh.colorSchemeName[%i];
    //         if(%i > 0) 
    //         {
    //             %brick.colorSchemeNodes[%this, %i] = %veh.colorSchemeNodes[%i];
    //         }
    //         %brick.colorSchemeFactoryColorGroup[%this, %i] = %veh.colorSchemeFactoryColorGroup[%i];
    //         %brick.colorSchemeColor[%this, %i] = %veh.colorSchemeColor[%i];
    //     }
    // }

    // function fxDTSBrick::respawnVehicle(%this)
    // {
    //     %veh = %this.vehicle;
    //     %cardata = %veh.dataBlock;

    //     if(%this.carAttributesSet[%cardata])
    //     {
    //         %veh.dataBlock.save
    //     }
    //     Parent::respawnVehicle(%this);
    // }

    // function sharkIImediumVehicle::onAdd(%this, %veh)
    // {
    //     Parent::onAdd(%this, %veh);

    //     %veh.spawnSharkIIMountedLightBot(2);

    //     %veh.playThread(0, lightsroot);
        
    //     %veh.setWheelPowered(0, 0);
    //     %veh.setWheelPowered(1, 0);

    //     // %veh.setWheelSpring(0, sharkIIfrontspring);
    //     // %veh.setWheelSpring(1, sharkIIfrontspring);

    //     %veh.hidenode(lights_headlightsLA1);
    //     %veh.hidenode(lights_headlightsLB1);
    //     %veh.hidenode(lights_headlightsRA1);
    //     %veh.hidenode(lights_headlightsRB1);
    //     %veh.hidenode(lights_dash1);
    //     %veh.hidenode(lights_idlesignalR1);
    //     %veh.hidenode(lights_idlesignalL1);
    //     %veh.hidenode(lights_brakeR1);
    //     %veh.hidenode(lights_brakeR2);
    //     %veh.hidenode(lights_brakeL1);
    //     %veh.hidenode(lights_brakeL2);
    //     %veh.hidenode(lights_reverse1);

    //     %veh.colorSchemeTarget = 0;

    //     %this.schedule(50, loadSpawnBrickAttributes, %veh);
    // }

    // function sharkIImediumVehicle::setDefaultBrickAttributes(%this, %veh)
    // {
    //     return sharkIIvehicle::setDefaultBrickAttributes(%this, %veh);
    // }

    // function sharkIImediumVehicle::loadSpawnBrickAttributes(%this, %veh)
    // {
    //     return sharkIIvehicle::loadSpawnBrickAttributes(%this, %veh);
    // }
    

    function sharkIImildVehicle::onAdd(%this, %veh)
    {
        Parent::onAdd(%this, %veh);

        %veh.partsBot = %veh.spawnSharkIIMountedLightBot(2);

        %veh.playThread(0, lightsroot);
        %veh.playThread(1, ttopup);
        
        %veh.setWheelPowered(0, 0);
        %veh.setWheelPowered(1, 0);

        // %veh.setWheelSpring(0, sharkIIfrontspring);
        // %veh.setWheelSpring(1, sharkIIfrontspring);

        // %veh.partsBot.hidenode(lights_headlightsLA1);
        // %veh.partsBot.hidenode(lights_headlightsLB1);
        // %veh.partsBot.hidenode(lights_headlightsRA1);
        // %veh.partsBot.hidenode(lights_headlightsRB1);
        %veh.partsBot.hidenode(lights_dash1);
        %veh.partsBot.hidenode(lights_idlesignalR1);
        %veh.partsBot.hidenode(lights_idlesignalL1);
        %veh.partsBot.hidenode(lights_brakeR1);
        %veh.partsBot.hidenode(lights_brakeR2);
        %veh.partsBot.hidenode(lights_brakeL1);
        %veh.partsBot.hidenode(lights_brakeL2);
        %veh.partsBot.hidenode(lights_reverse1);

        %veh.colorSchemeTarget = 0;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);
    }

    function sharkIImildVehicle::setDefaultBrickAttributes(%this, %veh)
    {
        return sharkIIvehicle::setDefaultBrickAttributes(%this, %veh);
    }

    function sharkIImildVehicle::loadSpawnBrickAttributes(%this, %veh)
    {
        return sharkIIvehicle::loadSpawnBrickAttributes(%this, %veh);
    }
    

    function sharkIIspicyVehicle::onAdd(%this, %veh)
    {
        Parent::onAdd(%this, %veh);

        %veh.partsBot = %veh.spawnSharkIIMountedLightBot(2);

        %veh.playThread(0, lightsroot);
        %veh.playThread(1, ttopup);
        
        %veh.setWheelPowered(0, 0);
        %veh.setWheelPowered(1, 0);

        // %veh.setWheelSpring(0, sharkIIfrontspring);
        // %veh.setWheelSpring(1, sharkIIfrontspring);
        
        %veh.setWheelTire(2, sharkIIfivespoke355tire);
        %veh.setWheelTire(3, sharkIIfivespoke355tire);

        // %veh.partsBot.hidenode(lights_headlightsLA1);
        // %veh.partsBot.hidenode(lights_headlightsLB1);
        // %veh.partsBot.hidenode(lights_headlightsRA1);
        // %veh.partsBot.hidenode(lights_headlightsRB1);
        %veh.partsBot.hidenode(lights_dash1);
        %veh.partsBot.hidenode(lights_idlesignalR1);
        %veh.partsBot.hidenode(lights_idlesignalL1);
        %veh.partsBot.hidenode(lights_brakeR1);
        %veh.partsBot.hidenode(lights_brakeR2);
        %veh.partsBot.hidenode(lights_brakeL1);
        %veh.partsBot.hidenode(lights_brakeL2);
        %veh.partsBot.hidenode(lights_reverse1);
        // %veh.hidenode(lights_signalR1);
        // %veh.hidenode(lights_signalL1);

        %veh.colorSchemeTarget = 0;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);
    }

    function sharkIIspicyVehicle::setDefaultBrickAttributes(%this, %veh)
    {
        return sharkIIvehicle::setDefaultBrickAttributes(%this, %veh);
    }

    function sharkIIspicyVehicle::loadSpawnBrickAttributes(%this, %veh)
    {
        return sharkIIvehicle::loadSpawnBrickAttributes(%this, %veh);
    }


    function sharkIIblockoVehicle::onAdd(%this, %veh)
    {
        Parent::onAdd(%this, %veh);

        %veh.partsBot = %veh.spawnSharkIIMountedLightBot(2);

        %veh.playThread(0, lightsroot);
        %veh.playThread(1, ttopup);

        // %veh.partsBot.hidenode(lights_headlightsLA1);
        // %veh.partsBot.hidenode(lights_headlightsLB1);
        // %veh.partsBot.hidenode(lights_headlightsRA1);
        // %veh.partsBot.hidenode(lights_headlightsRB1);
        %veh.partsBot.hidenode(lights_dash1);
        %veh.partsBot.hidenode(lights_idlesignalR1);
        %veh.partsBot.hidenode(lights_idlesignalL1);
        %veh.partsBot.hidenode(lights_brakeR1);
        %veh.partsBot.hidenode(lights_brakeR2);
        %veh.partsBot.hidenode(lights_brakeL1);
        %veh.partsBot.hidenode(lights_brakeL2);
        %veh.partsBot.hidenode(lights_reverse1);

        %veh.colorSchemeTarget = 0;

        %this.schedule(50, loadSpawnBrickAttributes, %veh);
    }

    function sharkIIblockoVehicle::setDefaultBrickAttributes(%this, %veh)
    {
        return sharkIIvehicle::setDefaultBrickAttributes(%this, %veh);
    }

    function sharkIIblockoVehicle::loadSpawnBrickAttributes(%this, %veh)
    {
        return sharkIIvehicle::loadSpawnBrickAttributes(%this, %veh);
    }

    function AIPlayer::RemoveBody(%obj)
    {
        if(%obj.getDatablock() == SharkIIPartsArmor.getID())
        {
            return;
        }
        else
        {
            return Parent::RemoveBody(%obj);
        }
    }
};
activatepackage(sharkIIPackage);

package onDriverEnterPackage
{
    function armor::onMount(%this, %obj, %vehicle, %node)
    {
        Parent::onMount(%this, %obj, %vehicle, %node);
        
        if(%node == 0 && isObject(%vehicle) && isFunction(%vehicle.dataBlock, onDriverEnter))
            %vehicle.dataBlock.onDriverEnter(%vehicle, %obj);
    }

};
activatePackage(onDriverEnterPackage);

function sharkIIVehicle::onDriverEnter(%this, %veh)
{   
    //onDriverEnter and onDriverLeave both are called many times (up to 14) for some reason.
    // The hasDriver variable makes it so these things are done only one time each.
    if(!%veh.hasDriver)
    {
        %veh.hasDriver = 1;
        
        %this.headlights(%veh, "restore");
        
        %this.SpeedCheck(%veh);
    }
}

function sharkIIVehicle::onDriverLeave(%this, %veh)
{       
    if(%veh.hasDriver)
    {
        %veh.hasDriver = 0;

        if(%veh.braking)
        {
            %veh.braking = 0;
            %veh.partsBot.hidenode(lights_brakeR2);
            %veh.partsBot.hidenode(lights_brakeL2); 

            if(%veh.headlightState > 0)
            {
                %veh.partsBot.unhidenode(lights_brakeR1);
                %veh.partsBot.unhidenode(lights_brakeL1); 
            }
            else
            {
                %veh.partsBot.unhidenode(lights_brakeR0);
                %veh.partsBot.unhidenode(lights_brakeL0); 
            }
        }
        
        %veh.reversing = 0;
        %veh.partsBot.unhidenode(lights_reverse0);
        %veh.partsBot.hidenode(lights_reverse1);

        cancel(%veh.SpeedCheckSchedule);
        if(%veh.signal != -11) %this.turnSignal(%veh, 0);
        %veh.mountedLightBot[2].setMountedLight(none);
    }
}

function sharkIIVehicle::onRemove(%this, %veh)
{
    %veh.removeMountedLightBot(2);
}

function sharkIIVehicle::SpeedCheck(%this, %veh)
{
    if(isEventPending(%veh.SpeedCheckSchedule)) return;
    if(!isObject(%veh)) return;
    
    %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
    
    if(!%veh.reversing && %veh.speed <= -3)
    {
        %veh.partsBot.hidenode(lights_reverse0);
        %veh.partsBot.unhidenode(lights_reverse1);
        %veh.reversing = 1;
    }
    else if(%veh.reversing && %veh.speed > -0.1)
    {
        %veh.partsBot.unhidenode(lights_reverse0);
        %veh.partsBot.hidenode(lights_reverse1);
        %veh.reversing = 0;
    }
    
    %veh.SpeedCheckSchedule = %this.schedule(250, "SpeedCheck", %veh);
}

// function sharkIIVehicle::SpeedCheck(%this, %veh)
// {
//     if(isEventPending(%veh.SpeedCheckSchedule)) return;
//     if(!isObject(%veh)) return;

//     %c = %veh.getMountedObject(0).client;
    
//     %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());

//     %veh.sidespeed = vectorDot(%veh.getVelocity(), VectorCross(%veh.getForwardVector(), %veh.getUpVector()));

//     %veh.airspeed = vectorDist("0 0 0", %veh.getVelocity())*2;

//     %veh.airaccel = (%veh.airspeed-%veh.prevairspeed) / (25/1000);
//     %veh.prevairspeed = %veh.airspeed;

//     %avgtotal = 0;
//     %avgcount = 250;
//     for(%i = %avgcount; %i > 0; %i--)
//     {
//         %veh.prevaccel[%i] = %veh.prevaccel[%i-1];
//         %avgtotal = %veh.prevaccel[%i] + %avgtotal;
//     }
//     %veh.prevaccel[0] = %veh.airaccel;
//     %avgtotal = %veh.prevaccel[0] + %avgtotal;

//     %avgaccel = %avgtotal / %avgcount;

//     %c.bottomprint( 

//                     // mfloor(%veh.speed*2*100)/100 NL
//                     // mfloor(%veh.acceleration*2*100) NL
//                     // mfloor(%veh.sidespeed*2*100)/100 NL
//                     "Velocity:" @ %veh.airspeed NL
//                     // "Global acceleration: " @ %veh.airaccel NL
//                     "Acceleration:" @ %veh.airaccel NL
//                     "Average acceleration:" @ %avgaccel NL
//                     %veh.prevaccel[0] NL
//                     %veh.prevaccel[1] NL
//                     %veh.prevaccel[2] NL
//                     %veh.prevaccel[3] NL
//                     %veh.prevaccel[4]);
    
//     if(!%veh.reversing && %veh.speed <= -3)
//     {
//         %veh.hidenode(lights_reverse0);
//         %veh.unhidenode(lights_reverse1);
//         %veh.reversing = 1;
//     }
//     else if(%veh.reversing && %veh.speed > -0.1)
//     {
//         %veh.unhidenode(lights_reverse0);
//         %veh.hidenode(lights_reverse1);
//         %veh.reversing = 0;
//     }
    
//     %veh.SpeedCheckSchedule = %this.schedule(25, "SpeedCheck", %veh);
// }
